#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	ofBackground(0, 0, 0);
	
	picture.loadImage("Red-Fish.png");
	
	for (int i = 0; i < 100; i++){

		particle myParticle;
		float vx = ofRandom(-4,4);
		float vy = ofRandom(-4,4);

		myParticle.setInitialCondition(ofGetWidth()/2,ofGetHeight()/2,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		//particles[i].addForce(0,0.04);  // gravity
		particles[i].addDampingForce();
		particles[i].update();
	}

}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0x000000);
	ofEnableAlphaBlending();

	for (int i = 0; i < particles.size(); i++){
		particles[i].draw(&picture);
	}
	ofDisableAlphaBlending();

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	for (int i = 0; i < particles.size(); i++){
		float vx = ofRandom(-2,2);
		float vy = ofRandom(-2,2);
	//	int mappedY = (y, 0, ofGetHeight(), 400, 800);
		particles[i].setInitialCondition(ofGetWidth()/2, ofGetHeight()/2,vx, vy);	
	}
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
